/*  $Id: datatypes.h,v 1.4 2003/10/14 15:52:10 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanCore="I/O Data"
//! header=core.h

#ifndef header_iotypes
#define header_iotypes

#if _MSC_VER > 1000
#pragma once
#endif

#ifdef WIN32

#if defined(__MINGW32__)
#  define __int8  char      
#  define __int16 short
#  define __int32 int       
# ifndef __int64
#  define __int64 long long
# endif
#endif

typedef __int8             cl_int8;
typedef unsigned __int8    cl_uint8;
typedef __int16            cl_int16;
typedef unsigned __int16   cl_uint16;
typedef __int32            cl_int32;
typedef unsigned __int32   cl_uint32;
typedef __int64            cl_int64;
typedef unsigned __int64   cl_uint64;
#else
typedef char               cl_int8;
typedef unsigned char      cl_uint8;
typedef short              cl_int16;
typedef unsigned short     cl_uint16;
typedef int                cl_int32;
typedef unsigned int       cl_uint32;
typedef long long          cl_int64;
typedef unsigned long long cl_uint64;
#endif

#endif
