/*  $Id: dom_character_data.h,v 1.7 2003/10/14 15:52:10 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanCore="XML"
//! header=core.h

#ifndef header_dom_character_data
#define header_dom_character_data

#if _MSC_VER > 1000
#pragma once
#endif

#include "dom_node.h"

class CL_DomCharacterData : public CL_DomNode
{
//! Construction:
public:
	CL_DomCharacterData();

	CL_DomCharacterData(CL_DomNode_Generic *impl);
	
	~CL_DomCharacterData();
	
//! Attributes:
public:
	unsigned long get_length();

//! Operations:
public:
	std::string substring_data(unsigned long offset, unsigned long count);
	
	void append_data(const std::string &arg);
	
	void insert_data(unsigned long offset, const std::string &arg);
	
	void delete_data(unsigned long offset, unsigned long count);
	
	void replace_data(unsigned long offset, unsigned long count, const std::string &arg);

//! Implementation:
protected:
	CL_DomCharacterData(CL_DomDocument &doc, unsigned short node_type);
};

#endif
