/*  $Id: dom_element.h,v 1.8 2003/10/14 15:52:10 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanCore="XML"
//! header=core.h

#ifndef header_dom_element
#define header_dom_element

#if _MSC_VER > 1000
#pragma once
#endif

#include "dom_node.h"

class CL_DomElement : public CL_DomNode
{
//! Construction:
public:
	CL_DomElement();
	
	CL_DomElement(CL_DomDocument &doc, const std::string &tag_name);

	CL_DomElement(CL_DomNode_Generic *impl);

	~CL_DomElement();

//! Attributes:
public:
	std::string get_tag_name() const;

//! Operations:
public:
	bool has_attribute(const std::string &name) const;

	std::string get_attribute(const std::string &name) const;

	std::string get_attribute(const std::string &name, const std::string &default_value) const;
	
	void set_attribute(const std::string &name, const std::string &value);
	
	void remove_attribute(const std::string &name);
	
	CL_DomNodeList get_elements_by_tag_name(const std::string &name);
	
	void normalize();

	std::string get_text() const;
};

#endif
