/*  $Id: dom_named_node_map.h,v 1.5 2003/10/14 15:52:10 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanCore="XML"
//! header=core.h

#ifndef header_dom_named_node_map
#define header_dom_named_node_map

#if _MSC_VER > 1000
#pragma once
#endif

class CL_DomNode;
class CL_DomNamedNodeMap_Generic;

class CL_DomNamedNodeMap
{
//! Construction:
public:
	CL_DomNamedNodeMap();
	
	CL_DomNamedNodeMap(CL_DomNode &node);

	~CL_DomNamedNodeMap();
	
//! Attributes:
public:
	int get_length() const;
	
//! Operations:
public:
	CL_DomNode get_named_item(const std::string &name);
	
	CL_DomNode set_named_item(const std::string &name);
	
	CL_DomNode remove_named_item(const std::string &name);
	
	CL_DomNode item(unsigned long index);
	
//! Implementation:
private:
	CL_DomNamedNodeMap_Generic *impl;
};

#endif
