/*  $Id: dom_processing_instruction.h,v 1.6 2003/10/14 15:52:10 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanCore="XML"
//! header=core.h

#ifndef header_dom_processing_instruction
#define header_dom_processing_instruction

#if _MSC_VER > 1000
#pragma once
#endif

#include "dom_node.h"

class CL_DomProcessingInstruction : public CL_DomNode
{
//! Construction:
public:
	CL_DomProcessingInstruction();
	
	CL_DomProcessingInstruction(CL_DomDocument &doc, const std::string &target, const std::string &data);

	CL_DomProcessingInstruction(CL_DomNode_Generic *impl);

	~CL_DomProcessingInstruction();
	
//! Attributes:
public:
	std::string get_target() const;
	
	std::string get_data() const;
	
	void set_data(const std::string &data);

//! Operations:
public:
};

#endif
