/*  $Id: inputdialog.h,v 1.6 2003/10/14 15:52:10 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanGUI="Controls"
//! header=gui.h

#ifndef header_inputdialog
#define header_inputdialog

#if _MSC_VER > 1000
#pragma once
#endif

#include "window.h"

class CL_InputDialog_Generic;
class CL_InputBox;

//: CL_InputDialog component
class CL_InputDialog : public CL_Window
{
//! Construction:
public:
	//: CL_InputDialog constructor
	CL_InputDialog(
		const std::string &title,
		const std::string &button1,
		const std::string &button2,
		const std::string &button3,
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	
	//: CL_InputDialog destructor
	virtual ~CL_InputDialog();

//! Operations:
public:
	//: Add inputbox with laber to dialog.
	CL_InputBox *add_input_box(const std::string &label = "",
		const std::string &default_value = "", int inputbox_width = 100);

//! Implementation:
private:
	CL_InputDialog(const CL_InputDialog &copy) : CL_Window(NULL, NULL) { return; } // disallow copy construction.

	CL_InputDialog_Generic *impl;
};

#endif
