/*  $Id: popupmenu.h,v 1.35 2003/10/14 15:52:10 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanGUI="Controls"
//! header=gui.h

#ifndef header_popupmenu
#define header_popupmenu

#if _MSC_VER > 1000
#pragma once
#endif

#include "component.h"
#include "menudata.h"

class CL_PopupMenu_Generic;

//: PopupMenu component
class CL_PopupMenu : public CL_Component, public CL_MenuData
{
//! Construction:
public:
	//: PopupMenu Constructor
	CL_PopupMenu(
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	
	//: PopupMenu Constructor
	CL_PopupMenu(
		const CL_Rect &pos,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	//: PopupMenu Destructor
	virtual ~CL_PopupMenu();

//! Attributes:
public:

//! Operations:
public:
	//: Popup the popupmenu.
	void popup(CL_Component *parent);
	
//! Signals:
public:
	//: This signal is emitted when the selection set of a tree changes.
	CL_Signal_v1<const CL_MenuNode &> &sig_selection_changed();

	//: This signal is emitted when the popupmenu is cancelled.
	CL_Signal_v0 &sig_cancelled();

//! Implementation:
private:
	CL_PopupMenu(const CL_PopupMenu &copy) : CL_Component(NULL, NULL), CL_MenuData(NULL) { return; } // disallow copy construction.
	CL_PopupMenu_Generic *impl;
};

#endif
