/*  $Id: inputbox_boring.h,v 1.4 2003/10/14 15:52:11 mbn Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

//! clanGUI="Style: Boring"
//! header=guistyleboring.h

#ifndef header_inputbox_boring
#define header_inputbox_boring

#if _MSC_VER > 1000
#pragma once
#endif

#include "../GUI/inputbox.h"
#include "../GUI/component_style.h"

class CL_Font;
class CL_StyleManager_Boring;

//: InputBox default style.
class CL_InputBox_Boring : public CL_ComponentStyle
{
//! Construction:
public:
	//: Constructor
	CL_InputBox_Boring(
		CL_InputBox *inputbox,
		CL_StyleManager_Boring *style);
	
	//: Destructor
	virtual ~CL_InputBox_Boring();

//! Operations:
public:
	//: Sets the size of the border around inputbox.
	void set_border_size(int size);

//! Implementation:
private:
	CL_Slot slot_paint;
	void on_paint();

	CL_Slot slot_activity;
	void on_activity();

	CL_InputBox *inputbox;

	CL_StyleManager_Boring *style;
	CL_ResourceManager *resources;
	CL_Font *font;
	CL_Font *font_disabled;

	int character_offset;

	bool show_cursor;
	unsigned int cursor_blink_time;

	int border_size;
	
//	int get_mouse_position(int x, int y);
};

#endif
