/*  $Id: browse_master.h,v 1.6 2003/10/14 15:52:11 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanNetwork="Browsing"
//! header=network.h

#ifndef header_browse_master
#define header_browse_master

#if _MSC_VER > 1000
#pragma once
#endif

class CL_IPAddress;
class CL_BrowseMaster_Generic;

class CL_BrowseMaster
//: Browse master.
//- <p>A browse master is a service that browse servers can register themselves to, and
//- browse clients can then connect to the master and get a list of servers.</p>
//- <p>Normally, this is used in games to provide a list of available servers.</p>
{
//! Construction:
public:
	//: Construct a browse master.
	CL_BrowseMaster();

	//: Browse Master Destructor
	virtual ~CL_BrowseMaster();

//! Attributes:
public:

//! Operations:
public:
	//: Setup port accepting browse clients and browse servers.
	void start_listen(const CL_IPAddress &bind_address);

	//: Stop listening.
	void stop_listen();

	//: Infinite browse master pump.
	void run();

//! Implementation:
private:
	CL_BrowseMaster_Generic *impl;
};

#endif
