/*  $Id: slot.h,v 1.17 2003/10/14 15:52:11 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanSignal="System"
//! header=signals.h

#ifndef header_slot
#define header_slot

#if _MSC_VER > 1000
#pragma once
#endif

#include "slot_generic.h"
#include <stdlib.h>

//: Slot class
class CL_Slot
{
//! Construction:
public:
	//: Create an unconnected slot.
	CL_Slot()
	: impl(NULL)
	{
	}

	//: Copy a slot.
	CL_Slot(const CL_Slot &copy)
	: impl(copy.impl)
	{
		if (impl != NULL) impl->add_slot_ref();
	}

	//: Slot destructor
	~CL_Slot()
	{
		if (impl != NULL) impl->release_slot_ref();
	}

//! Operators:
	//: Slot copy operator
	void operator =(const CL_Slot &copy)
	{
		if (impl) impl->release_slot_ref();
		impl = copy.impl;
		if (impl) impl->add_slot_ref();
	}

//! Implementation:
public:
	//: Slot constructor
	CL_Slot(CL_Slot_Generic *impl)
	: impl(impl)
	{
		if (impl != NULL) impl->add_slot_ref();
	}

	//: Slot Generic Implementation
	CL_Slot_Generic *impl;
};

#endif
