/*  $Id: slot_generic.h,v 1.10 2003/10/14 15:52:11 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanSignal="System"
//! header=signals.h

#ifndef header_slot_generic
#define header_slot_generic

#if _MSC_VER > 1000
#pragma once
#endif

//: Slot Generic Class
class CL_Slot_Generic
{
//! Construction:
public:
	//: Slot Generic Constructor
	CL_Slot_Generic() : slot_ref_count(0), signal_ref_count(0) { return; }

	//: Slot Generic Destructor
	virtual ~CL_Slot_Generic() { return; }

//! Attributes:
public:
	//: Get slot ref
	int get_slot_ref() const { return slot_ref_count; }

	//: Get signal ref
	int get_signal_ref() const { return signal_ref_count; }

//! Operations:
public:
	//: Add slot ref
	void add_slot_ref() { slot_ref_count++; }

	//: Release slot ref
	void release_slot_ref() { slot_ref_count--; check_delete(); }

	//: Add signal ref
	void add_signal_ref() { signal_ref_count++; }

	//: Release signal ref
	void release_signal_ref() { signal_ref_count--; check_delete(); }

//! Implementation:
private:
	void check_delete()
	{
		if (slot_ref_count == 0 && signal_ref_count == 0) delete this;
	}

	int slot_ref_count;

	int signal_ref_count;
};

#endif
